Index: trunk/packages/invirt-xen-config/debian/changelog
===================================================================
--- trunk/packages/invirt-xen-config/debian/changelog	(revision 1455)
+++ trunk/packages/invirt-xen-config/debian/changelog	(revision 1457)
@@ -1,2 +1,8 @@
+invirt-xen-config (0.0.11) unstable; urgency=low
+
+  * Automatically startup sysvms if they're not running already
+
+ -- Evan Broder <broder@mit.edu>  Fri, 31 Oct 2008 09:47:15 -0400
+
 invirt-xen-config (0.0.10) unstable; urgency=low
 
Index: trunk/packages/invirt-xen-config/debian/invirt-xen-config.init
===================================================================
--- trunk/packages/invirt-xen-config/debian/invirt-xen-config.init	(revision 1455)
+++ trunk/packages/invirt-xen-config/debian/invirt-xen-config.init	(revision 1457)
@@ -14,10 +14,11 @@
 DESC="Invirt Xen host"
 PARENTPACKAGE=xend
-GEN_FILES=(
-    /etc/xen/xend-config.sxp.invirt
-    /etc/xen/sysvms/s_master
-    /etc/xen/sysvms/s_remote
-    /etc/xen/sysvms/s_console
-    )
+GEN_FILES=(/etc/xen/xend-config.sxp.invirt)
+SYSVMS=(s_master s_remote s_console)
+i=1
+for vm in "${SYSVMS[@]}"; do
+    GEN_FILES[$i] = "$vm"
+    i=$((i + 1)
+done
 
 dpkg -s "$PACKAGE" >/dev/null 2>/dev/null || exit 0
@@ -26,6 +27,40 @@
 . /lib/init/std-init.sh
 
+start_sysvm() {
+    # Attempt to start a sysvm, but only if it's not running already
+    # somewhere on the cluster
+    
+    VM="$1"
+    DISK="/dev/xenvg/${VM}_hda"
+    
+    # Don't bother trying to start the VM if it's already running
+    if xm list "$1" >/dev/null 2>&1; then
+        return 1
+    fi
+    
+    if lvchange -a n "$DISK" >/dev/null 2>&1 && lvchange -a ey "$DISK" >/dev/null 2>&1; then
+        # If we can lock on the VM's disk, then the VM isn't running
+        [ "$VERBOSE" != no ] && log_daemon_msg "Starting sysvm $VM"
+        xm create "sysvms/$VM" >/dev/null
+        [ "$VERBOSE" != no ] && log_end_msg $?
+        RET=0
+    else
+        RET=1
+    fi
+    
+    # Regardless of whether we could get the lock or not, the
+    # lvchange -a n probably disabled the LV somewhere; be sure we
+    # clean up
+    lvchange -a y "$DISK" >/dev/null 2>&1
+    
+    return $RET
+}
+
 do_startup() {
     gen_files
+    
+    for vm in "${SYSVMS[@]}"; do
+        start_sysvm "$vm"
+    done
     
     echo 1 >/proc/sys/net/ipv4/ip_forward
